message("DownloadOpenBLAS starting...")

set(OPENBLAS_LOCAL_PATH ${CMAKE_CURRENT_LIST_DIR}/external_dependencies/OpenBLAS)

include(FetchContent)

#####################
# Download OpenBLAS #
#####################
FetchContent_Declare(
    OpenBLAS
    SOURCE_DIR ${OPENBLAS_LOCAL_PATH}
    GIT_REPOSITORY https://github.com/xianyi/OpenBLAS.git
)

set(FETCHCONTENT_QUIET FALSE)

if(NOT OpenBLAS_POPULATED)
    FetchContent_Populate(OpenBLAS)
    #add_subdirectory(${OPENBLAS_LOCAL_PATH} ${OPENBLAS_LOCAL_PATH}/build)
endif()

##################
# Build OpenBLAS #
##################
execute_process(
    COMMAND cmake -j ${N_CORES} .
    WORKING_DIRECTORY ${OPENBLAS_LOCAL_PATH}
    RESULT_VARIABLE rv
)
if(NOT rv STREQUAL "0")
    message("OpenBLAS build: cmake .: ${rv}")
endif()

# Build library
execute_process(
    COMMAND cmake --build . -j ${N_CORES} --config Release
    WORKING_DIRECTORY ${OPENBLAS_LOCAL_PATH}
    RESULT_VARIABLE rv
)
if(NOT rv STREQUAL "0")
    message("OpenBLAS build: cmake --build: ${rv}")
endif()

set_target_properties(openblas PROPERTIES LINK_FLAGS)
add_subdirectory(${OPENBLAS_LOCAL_PATH})

find_package(OpenBLAS)

if(NOT OpenBLAS_FOUND)
    message(FATAL_ERROR "OpenBLAS was not downloaded successfully!")
endif()

