message("FindOpenBLAS starting...")

set(OpenBLAS_ROOT external_dependencies/OpenBLAS)

FIND_PATH(
    OpenBLAS_INCLUDE_DIR

    NAMES
    cblas.h

    HINTS
        ${OpenBLAS_INCLUDE_DIRECTORY}
        $ENV{OpenBLAS_INCLUDE_DIRECTORY}
        ${ROOT_DIR}/external_dependencies/OpenBLAS
        /usr

        PATH_SUFFIXES
        include
        include/x86_64-linux-gnu
)

#IF(${OpenBLAS_INCLUDE_DIR} MATCHES "^.*external_dependencies.*$")
#    # If OpenBLAS is downloaded locally, the library will be compiled during build-time
#    INCLUDE(FindPackageHandleStandardArgs)
#    FIND_PACKAGE_HANDLE_STANDARD_ARGS(
#            OpenBLAS
#            "OpenBLAS was NOT found!"
#            OpenBLAS_INCLUDE_DIR)
#
#    if(OpenBLAS_FOUND)
#        message(STATUS "OpenBLAS is downloaded locally: ${OpenBLAS_INCLUDE_DIR}")
#    endif()
#
#else()

    FIND_LIBRARY(
        OpenBLAS_LIBRARIES

        NAMES
        ${LIB_PREFIX}openblas.${LIB_SUFFIX}

        HINTS
        ${OpenBLAS_LIBRARY_DIRECTORY}
        $ENV{OpenBLAS_LIBRARY_DIRECTORY}
        ${ROOT_DIR}/external_dependencies/OpenBLAS
        /usr

        PATH_SUFFIXES
        lib
        lib/x86_64-linux-gnu
        local
    )

    # Set OpenBLAS_Found
    INCLUDE(FindPackageHandleStandardArgs)
    FIND_PACKAGE_HANDLE_STANDARD_ARGS(
            OpenBLAS

            FAIL_MESSAGE
                "OpenBLAS was NOT found!"

            REQUIRED_VARS
                OpenBLAS_INCLUDE_DIR
                OpenBLAS_LIBRARIES
    )

#endif()

IF (OpenBLAS_LIBRARIES)
   MESSAGE(STATUS "Found OpenBLAS libraries: ${OpenBLAS_LIBRARIES}")
   MESSAGE(STATUS "Found OpenBLAS include: ${OpenBLAS_INCLUDE_DIR}")
ELSE()
    MESSAGE("Could not find OpenBLAS")
ENDIF()
