/**
 * DESCRIPTION OF THE FILE
 *
 * @author Michal Kravčenko
 * @date 4.9.18 -
 */

#ifndef LIB4NEURO_EXPRTKWRAPPER_H
#define LIB4NEURO_EXPRTKWRAPPER_H

#include <memory>
#include <vector>

#include "../settings.h"

class ExprtkWrapper {

public:

    /**
     * Struct used to access private properties from
     * the serialization function
     */
    struct access;

    /**
     *
     * @param expression_string
     * @param var_dim
     */
    LIB4NEURO_API ExprtkWrapper( std::string expression_string );

    /**
     *
     */
    LIB4NEURO_API ExprtkWrapper( );

    /**
     *
     */
    LIB4NEURO_API ~ExprtkWrapper();

    /**
     *
     * @param x1
     * @param x2
     * @param x3
     * @param x4
     * @return
     */
    LIB4NEURO_API double eval(double x1 = 0.0, double x2 = 0.0, double x3 = 0.0, double x4 = 0.0);

    /**
     *
     * @param p
     * @return
     */
    LIB4NEURO_API double eval(std::vector<double> &p);

private:

    /**
     * Private properties
     *
     * They are hidden in .cpp file
     * to isolate Exprtk dependency from header
     */
    class ExprtkWrapperImpl;
    ExprtkWrapperImpl *p_impl;

};

#endif //LIB4NEURO_EXPRTKWRAPPER_H
